                MEMBER('TEACH')


CREATEMODE  EQUATE(4)
DOCS    FILE,PRE(DOC),DRIVER('TOPSPEED'),CREATE
RECORD  RECORD
DATE    LONG
TITLE   STRING(25)
PATH    STRING(50)
APPPATH STRING(50)
ID      LIKE(CLA:ID)
SUBJECT LIKE(CLA:SUBJECT)
TYPE    BYTE
GRANUM  LIKE(GRA:GRANUM)
SSN     LIKE(STU:SSN)
..

DBASESTU    FILE,PRE(DBS),DRIVER('DBASE3'),NAME('STUINFO.DBF'),CREATE
RECORD      RECORD
STUGRP2     LIKE(STU:RECORD)
SNAME       LIKE(NAM:NAME)
AVG         STRING(@N4.1)
RANK        STRING(@N4.1)
..

DBASECLA    FILE,PRE(DBC),DRIVER('DBASE3'),NAME('CLASINFO.DBF'),CREATE
RECORD      RECORD
CLAGRP      GROUP
NAME        LIKE(CLA:NAME)
SDATE       STRING(@D1)
EDATE       STRING(@D1)
STIME       STRING(@T3)
ETIME       STRING(@T3)
SCHOOLID    LIKE(CLA:SCHOOLID)
AVGAVG      STRING(5)
TOTSTU      STRING(3)
.
NAMGRP      GROUP
STUNAME     LIKE(NAM:NAME)
AVG         STRING(5)
RANK        STRING(3)
SSN         LIKE(NAM:SSN)
.
ASSGRP      GROUP
ASSNAME     LIKE(ALL:NAME)
DDATE       STRING(@D1)
.
USERNAME    LIKE(USERNAME)
..


DOCQUE  QUEUE,PRE(DOQ)
DOCGRP  LIKE(DOC:RECORD) !WONT SORT
POINTER LONG
.
TMPQUE  QUEUE,PRE(TMP)
TITLE   STRING(15)
PATH    STRING(50)
APPPATH STRING(50)
TYPE    BYTE
POINTER LONG
.

SAVPATH     STRING(50)
DOCPATH     STRING(50)
PGMPATH     STRING(50)
SAV:DOQPATH  STRING(50)
ADDRESS1    STRING(25)
ADDRESS2    STRING(25)
CSZ         STRING(35)
MERGE       BYTE

WINVER      ULONG(0)
VERGRP      GROUP,OVER(WINVER),PRE(WIN)
REV         BYTE
VER         BYTE
NT          USHORT
.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DODOC   PROCEDURE(DOCTYPE,THECLASS,THEASSIGNMENT)

        CODE
        FILDOCQUEUE(THECLASS); SETDOC(DOCTYPE)
        IF DOCTYPE > 30
        IF BUTTON:NO = YESNO('Press YES to create a new document or NO to open and existing one.')
        SHOWDOCS(1,CUR:ID); ELSE GET(DOCS,0). !FORCE ERROR
        ELSE
        GET(DOCQUE,DOQ:TYPE,DOQ:ID,DOQ:SUBJECT,DOQ:GRANUM,DOQ:SSN)
        .
        IF NOT ERROR(); RUNDOC(DOQ:APPPATH,DOQ:PATH); ELSE
        GETDOC(CREATEMODE,DOCTYPE).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SHOWDOCS    PROCEDURE(MODE,THECLASS)
!MODE 0=NORMAL, 1=SELECT DOCUMENT, 2=SELECT TEMPLATE, 3=SET UP
TABNUM      BYTE
SORT        BYTE
DOCTYPE     BYTE(31)     !DEFAULT = LETTER
TMPTYPE     BYTE
VIEW1       LIKE(CLA:ID)
NDX         SHORT
LENGTH      BYTE

window WINDOW('Class Mate Documents'),AT(,,285,173),FONT('Arial',8,,FONT:regular),CENTER,GRAY
       SHEET,AT(10,10,268,157),USE(tabnum)
         TAB('Documents'),USE(?DOCS)
           OPTION('View Documnets for:'),AT(182,27,83,35),USE(VIEW1),BOXED
             RADIO('All Classes'),AT(192,39),VALUE('0')
             RADIO('This Class Only'),AT(192,51),VALUE('1')
           END
           LIST,AT(24,31,141,112),FONT(,,0800000H,),COLOR(,0FFH,0C0C0C0H),USE(?DOCQUE),HVSCROLL,FORMAT('37L|~Date~C@D1@102L|~Description~C@s25@201L|~Document Path~C@s50@40L|~Applicatio' &|
               'n Path~C@s50@'),FROM(DOCQUE)
           BUTTON('Attach'),AT(232,71),USE(?attach)
           BUTTON('Delete'),AT(232,95,33,14),USE(?delete)
           BUTTON('Edit'),AT(184,95),USE(?edit)
           BUTTON('Open'),AT(209,121),USE(?open)
           BUTTON('New'),AT(184,71),USE(?new)
         END
         TAB('Templates'),USE(?temps)
           BUTTON('Open'),AT(213,46,38,14),USE(?topen)
           LIST,AT(26,46,153,98),FONT(,,0800000H,),COLOR(,0FFH,0C0C0C0H),USE(?TMPQUE),HVSCROLL,FORMAT('101L|~Description~C@S25@203L|~Path~C@s50@20L|~Application~C@s50@'), |
               FROM(TMPQUE)
           BUTTON('Edit'),AT(213,74,38,14),USE(?tedit)
           BUTTON('Delete'),AT(213,130,38,14),USE(?tdelete)
           BUTTON('New'),AT(213,102,38,14),USE(?tnew)
         END
         TAB('Set Up'),USE(?setup)
           STRING('Teacher Name:'),AT(42,31)
           STRING('Address 1:'),AT(56,45),USE(?String3)
           STRING('Address 2:'),AT(56,59)
           STRING('City / State / Zip:'),AT(38,74)
           ENTRY(@s25),AT(94,31),USE(username)
           ENTRY(@s25),AT(94,45),USE(address1)
           ENTRY(@s25),AT(94,59),USE(address2)
           ENTRY(@s35),AT(94,74),USE(CSZ)
           OPTION('Use Sample Templates for:'),AT(31,89,223,23),USE(tmptype),BOXED
             RADIO('Microsoft Word'),AT(58,97),VALUE('1')
             RADIO('Windows Write or WordPad'),AT(128,97),VALUE('2')
           END
           CHECK('Enable Mail Merge'),AT(108,115),USE(merge),VALUE('1','0')
           STRING('Word Processor'),AT(21,127,53,10)
           ENTRY(@s50),AT(82,131,119,12),USE(PGMPATH)
           STRING('Command Line:'),AT(25,137)
           BUTTON('Browse'),AT(206,131,38,12),USE(?browse)
         END
       END
       BUTTON('Done'),AT(129,148),USE(?done)
     END

       CODE
       OPEN(WINDOW); DO STARTIT
       ACCEPT
       CASE EVENT()
       OF EVENT:GAINFOCUS
       OF EVENT:NEWSELECTION
       IF TABNUM = 1; GET(DOCQUE,CHOICE(?DOCQUE))
       ELSE GET(TMPQUE,CHOICE(?TMPQUE));  IF TMP:TYPE = 50; ENABLE(?TDELETE); ELSE; DISABLE(?TDELETE).
       .
       IF INRANGE(MODE,1,2) AND KEYCODE() = MOUSELEFT2; POST(EVENT:ACCEPTED,?DONE).

       OF EVENT:ACCEPTED
       IF ACCEPTED() = ?DONE; BREAK
       ELSE DO CHECK.
       ..
       IF MODE = 0 OR MODE = 255; FREE(DOCQUE); FREE(TMPQUE); CLOSE(DOCS).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CHECK   ROUTINE
        
        CASE ACCEPTED()
        OF ?NEW; CLEAR(DOQ:PATH); GETDOC(CREATEMODE,DOCTYPE)
        OF ?ATTACH; CLEAR(DOQ:PATH); GETDOC(ADDMODE,DOCTYPE)
        OF ?EDIT; GETDOC(EDITMODE,DOQ:TYPE)
        OF ?OPEN; RUNDOC(DOQ:APPPATH,DOQ:PATH)
        OF ?DELETE; PUTDOC(DELMODE); SELECT(?DOCQUE,1); POST(EVENT:NEWSELECTION,?DOCQUE)
        OF ?VIEW1; IF VIEW1; VIEW1 = CUR:ID.
        FILDOCQUEUE(VIEW1)
        OF ?TOPEN; ; SHOWMSG('If you change the file name or extention of the template file, you must update the template information to reflect the new information.')
        RUNDOC(TMP:APPPATH,TMP:PATH)
        OF ?TNEW; CLEAR(TMPQUE); GETTMP(ADDMODE)
        OF ?TEDIT; GETTMP(EDITMODE)
        OF ?TDELETE; GETTMP(DELMODE)
        OF ?BROWSE; PGMPATH = BROWSE(1); IF PGMPATH; POST(EVENT:ACCEPTED,?PGMPATH).; DISPLAY
        PUTINI('USER','DOCPGM',PGMPATH,'.\CLASMATE.INI')
        OF ?USERNAME; PUTINI('USER','USERNAME',USERNAME,'./clasmate.INI')
        OF ?ADDRESS1; PUTINI('USER','ADDRESS1',ADDRESS1,'./clasmate.INI')
        OF ?ADDRESS2; PUTINI('USER','ADDRESS2',ADDRESS2,'./clasmate.INI')
        OF ?CSZ; PUTINI('USER','CSZ',CSZ,'./clasmate.INI')
        OF ?MERGE; PUTINI('DEFAULTS',MERGE,,'./CLASMATE.INI')
        OF ?TMPTYPE; DO CHANGETEMPS
        OF ?PGMPATH; DO CHANGEPGM
        .
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
STARTIT     ROUTINE
       IF NOT RECORDS(DOCQUE); FILDOCQUEUE(THECLASS).
       SELECT(?TMPQUE,1); GET(TMPQUE,1); SELECT(?DOCQUE,1); GET(DOCQUE,1); VIEW1 = CUR:ID
       CASE MODE
       OF 0
       OF 1; DISABLE(?TEMPS); DISABLE(?SETUP)
       WINDOW{PROP:TEXT} = 'Select the document to copy'
       OF 2; DISABLE(?DOCS); DISABLE(?SETUP)
       WINDOW{PROP:TEXT} = 'Select the template to copy'
       OF 3; TABNUM = 3
       OF 255; IF RECORDS(DOCQUE); DO DELCLASSDOCS; ELSE; RETURN.
       ELSE DOCTYPE = MODE
       .
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CHANGETEMPS ROUTINE
       
       LOOP NDX = 1 TO RECORDS(TMPQUE); GET(TMPQUE,NDX); IF TMP:TYPE > 49; CYCLE.
       LENGTH = LEN(CLIP(TMP:PATH)); PAT:EXT = TMP:PATH[LENGTH - 2:LENGTH]
       IF PAT:EXT <> 'WRI' AND PAT:EXT <> 'DOC'; CYCLE.
       CASE TMPTYPE
       OF 1; TMP:PATH[LENGTH - 2:LENGTH] = 'DOC'; MERGE = 1; DISPLAY
       OF 2; TMP:PATH[LENGTH - 2:LENGTH] = 'WRI'; MERGE = 0; DISPLAY
       .
       GET(DOCS,TMP:POINTER); DOC:PATH = TMP:PATH; PUT(DOCS); PUT(TMPQUE)
       .
       POST(EVENT:ACCEPTED,?MERGE)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CHANGEPGM   ROUTINE
        IF BUTTON:YES = YESNO('Would you like to change the default program used to create documents?')
        LOOP NDX = 1 TO RECORDS(TMPQUE); GET(TMPQUE,NDX); IF TMP:TYPE > 49; CYCLE.
        TMP:APPPATH = PGMPATH
        GET(DOCS,TMP:POINTER); DOC:APPPATH = TMP:APPPATH; PUT(DOCS); PUT(TMPQUE)
        ..
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
DELCLASSDOCS    ROUTINE
        SHOWMSG('The class you are deleting has documents attached to it. You should delete any documents that you will not need in the future. ' |
        & 'Be careful not to delete document files that are shared by other classes.')
        LOOP NDX = 1 TO RECORDS(DOCQUE); GET(DOCQUE,NDX)
        GET(DOCS,DOQ:POINTER); DOC:ID = 0; PUT(DOCS).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
GETDOC  PROCEDURE(MODE,DOCTYPE)
NDX         SHORT
RUN         BYTE
RUNGRP      GROUP,PRE(RUN)
DOCGRP      LIKE(DOC:RECORD)
POINTER     LIKE(DOQ:POINTER)
.
RUN:TMPPATH LIKE(DOC:PATH)
CREATE  BYTE(1)

window WINDOW('Document Info.'),AT(,,264,170),FONT('Arial',8,,FONT:regular),CENTER,GRAY,AUTO
       STRING('Description:'),AT(36,99)
       STRING('Document Path / File:'),AT(4,129,70,11),USE(?DOCTMP)
       STRING('Application Path / File:'),AT(4,113,70,11)
       OPTION('Create It'),AT(50,49,168,41),USE(create),BOXED
         RADIO('Using the default application and template'),AT(60,57),USE(?default),VALUE('1')
         RADIO('Copy an existing document'),AT(60,67),USE(?copy),VALUE('2')
         RADIO('Using a custom application and/or template'),AT(60,77),USE(?Custom),VALUE('3')
       END
       OPTION('Document Type'),AT(50,6,168,41),USE(doctype),BOXED
         RADIO('Sylabus'),AT(61,14),VALUE('1')
         RADIO('Lesson Plan'),AT(61,24),VALUE('2')
         RADIO('Assignment'),AT(61,34),VALUE('11')
         RADIO('Test'),AT(116,14),VALUE('12')
         RADIO('Student Notes'),AT(116,24),VALUE('21')
         RADIO('Custom'),AT(176,24),VALUE('50')
         RADIO('Letter'),AT(116,34),VALUE('31')
         RADIO('Other'),AT(176,14),VALUE('32')
       END
       BUTTON('Pick'),AT(232,129,26,12),USE(?pick)
       ENTRY(@S25),AT(76,97),USE(RUN:TITLE),SCROLL
       ENTRY(@s50),AT(76,129,107,12),USE(RUN:path),SCROLL,REQ
       BUTTON('Browse'),AT(191,129,38,12),USE(?browse)
       ENTRY(@s50),AT(76,113,107,12),USE(RUN:apppath),SCROLL,REQ
       BUTTON('Browse'),AT(191,113,38,12),USE(?browse2)
       BUTTON('OK'),AT(75,149),USE(?OK),REQ
       BUTTON('Cancel'),AT(145,149),USE(?cancel)
     END
        CODE
        OPEN(WINDOW); DO STARTIT
        ACCEPT
        CASE ACCEPTED()
        OF ?OK; DO EXISTS; DOCQUE = RUNGRP; DO CHKDOC; BREAK
        OF ?CANCEL; BREAK
        ELSE; DO CHECK
        ..
        IF RUN; CLOSE(WINDOW); RUNDOC(RUN:APPPATH,RUN:PATH).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CHECK   ROUTINE
        CASE ACCEPTED()
        OF ?BROWSE;  IF MODE = CREATEMODE; RUN:TMPPATH = BROWSE(2); POST(EVENT:ACCEPTED,?RUN:PATH); ELSE; RUN:PATH = BROWSE(2).
        OF ?BROWSE2; RUN:APPPATH = BROWSE(1)
        OF ?DOCTYPE; SETDOC(DOCTYPE); RUNGRP = DOCQUE; RUN:TMPPATH = TMP:PATH
        IF MODE = ADDMODE; CLEAR(RUN:PATH).

        OF ?RUN:PATH; IF MODE = CREATEMODE; SETDOC(DOCTYPE,RUN:TMPPATH); RUNGRP = DOCQUE.
        OF ?PICK; IF MODE = ADDMODE; SHOWDOCS(1,CUR:ID); RUN:PATH = DOQ:PATH; RUN:APPPATH = DOQ:APPPATH
        ELSE SHOWDOCS(2,CUR:ID); RUN:APPPATH = TMP:APPPATH; RUN:TMPPATH = TMP:PATH; SETDOC(DOCTYPE)
        .
        OF ?CREATE; CASE CREATE
        OF 1; SETDOC(DOCTYPE); RUNGRP = DOCQUE; RUN:TMPPATH = TMP:PATH
            DISABLE(?BROWSE); DISABLE(?BROWSE2); DISABLE(?RUN:APPPATH); DISABLE(?RUN:PATH); DISABLE(?PICK)
        OF 2; SHOWDOCS(1,CUR:ID); RUN:TMPPATH = DOQ:PATH; RUN:APPPATH = DOQ:APPPATH
            DISABLE(?BROWSE); DISABLE(?BROWSE2); DISABLE(?RUN:APPPATH); DISABLE(?RUN:PATH); DISABLE(?PICK)
        OF 3; ENABLE(?BROWSE); ENABLE(?BROWSE2); ENABLE(?RUN:APPPATH); ENABLE(?RUN:PATH)
            CLEAR(TMP:PATH); CLEAR(DOSFILENAME); ENABLE(?PICK)
        ..
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
EXISTS  ROUTINE
        
        IF CREATE = 2  AND BUTTON:NO = YESNO('Press YES if you would like to create a new copy of ' & clip(doq:title) |
        & ' to edit, or NO to share the existing copy as is.')
        RUN:PATH = RUN:TMPPATH.

        IF MODE <> EDITMODE AND DOCTYPE < 30; DOCQUE = RUNGRP; GET(DOCQUE,DOQ:TYPE,DOQ:ID,DOQ:SUBJECT,DOQ:GRANUM,DOQ:SSN)
        IF NOT ERROR(); IF BUTTON:YES = YESNO('A document of this type already exixts for this class or assignment. ' |
        & 'Press YES to create a new "custom" document of this type, or NO to cancel.')
        RUN:TYPE = 50; ELSE RETURN...
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CHKDOC  ROUTINE
        CASE MODE
        OF ADDMODE OROF EDITMODE; IF FILEEXISTS(RUN:APPPATH) AND FILEEXISTS(RUN:PATH); PUTDOC(MODE).

        OF CREATEMODE
         IF FILEEXISTS(RUN:APPPATH) AND FILEEXISTS(RUN:TMPPATH)
        RUN = 1; PUTDOC(MODE); DOSFILENAME = RUN:TMPPATH; COPY(DOSFILE,RUN:PATH)
        ELSE
        IF BUTTON:YES = YESNO('The template file ' & clip(RUN:TMPPATH) & ' or the application ' & clip(run:apppath) & ' does not exist. If you changed the name or extention to the template file, ' |
        & 'you must change the template information. Would you like to change the template information now?');
        TMP:TYPE = DOQ:TYPE; GET(TMPQUE,TMP:TYPE); GETTMP(EDITMODE).
        .
        .
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
STARTIT ROUTINE
        CASE MODE
        OF ADDMODE; RUN:APPPATH = PGMPATH; DISABLE(?CREATE); ENABLE(?BROWSE); ENABLE(?BROWSE2)
        WINDOW{PROP:TEXT} = 'Attach an existing document'
        OF EDITMODE; DISABLE(?DOCTYPE); DISABLE(?CREATE); DISABLE(?PICK); RUNGRP = DOCQUE
        WINDOW{PROP:TEXT} = 'Change an existing document'
        OF CREATEMODE; DOQ:APPPATH = PGMPATH; CLEAR(TMP:PATH); POST(EVENT:ACCEPTED,?CREATE)
        ?DOCTMP{PROP:TEXT} = 'Template Path / File'; ?RUN:PATH{PROP:USE} = RUN:TMPPATH
        ?RUN:PATH{PROP:REQ} = 0; WINDOW{PROP:TEXT} = 'Create a new document'
        .
        IF MODE <> EDITMODE; DOQ:DATE = CDATE; POST(EVENT:ACCEPTED,?DOCTYPE).
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PUTDOC  PROCEDURE(MODE)
        CODE
        IF DOQ:PATH <> ''
        CASE MODE
        OF ADDMODE OROF CREATEMODE; DOC:RECORD = DOCQUE; ADD(DOCS); DOQ:POINTER = POINTER(DOCS); ADD(DOCQUE,DOQ:TYPE,DOQ:ID,DOQ:SUBJECT,DOQ:GRANUM,DOQ:SSN);
        OF EDITMODE; GET(DOCS,DOQ:POINTER); DOC:RECORD = DOCQUE; PUT(DOCQUE); PUT(DOCS)
        OF DELMODE; GET(DOCS,DOQ:POINTER); DELETE(DOCS); DELETE(DOCQUE)
        IF BUTTON:YES = YESNO('Would you like to also delete the file from your hard drive?')
        DOSFILENAME = DOQ:PATH; REMOVE(DOSFILE).
        ..
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
GETTMP  PROCEDURE(MODE)
TMPGRP  LIKE(TMPQUE)

window WINDOW('Class Mate Templates'),AT(,,264,134),FONT('Arial',8,,FONT:regular),CENTER,GRAY,AUTO
       STRING('Template Description:'),AT(7,12)
       STRING('Template Path / File:'),AT(13,27)
       STRING('Application Path / File:'),AT(6,43),USE(?String3)
       OPTION('Template Type'),AT(48,60,168,41),USE(TMP:TYPE),BOXED
         RADIO('Sylabus'),AT(57,68),VALUE('1')
         RADIO('Lesson Plan'),AT(57,78),VALUE('2')
         RADIO('Assignment'),AT(57,88),VALUE('11')
         RADIO('Test'),AT(115,68),VALUE('12')
         RADIO('Student Notes'),AT(115,78),VALUE('21')
         RADIO('Custom'),AT(177,78),VALUE('50')
         RADIO('Letter'),AT(115,88,31,11),VALUE('31')
         RADIO('Other'),AT(177,68),VALUE('32')
       END
       ENTRY(@s25),AT(77,11),USE(TMP:title)
       ENTRY(@s50),AT(77,27),USE(TMP:path),REQ
       ENTRY(@s50),AT(77,42),USE(TMP:apppath),REQ
       BUTTON('Browse'),AT(218,27,38,12),USE(?browse)
       BUTTON('Browse'),AT(218,42,38,12),USE(?browse2)
       BUTTON('OK'),AT(56,113),USE(?OK),REQ
       BUTTON('Cancel'),AT(163,113),USE(?cancel)
     END

        CODE
        OPEN(WINDOW)
        IF MODE = ADDMODE; TMP:APPPATH = PGMPATH; TMP:TYPE = 50; WINDOW{PROP:TEXT} = 'Create a new template'
        ELSIF MODE = EDITMODE; DISABLE(?TMP:TYPE); WINDOW{PROP:TEXT} = 'Change an existing template'
        ELSIF MODE = DELMODE; DO PUTTMP; RETURN.
        ACCEPT
        CASE ACCEPTED()
        OF ?CANCEL; BREAK
        OF ?OK; TMPGRP = TMPQUE
        IF MODE = ADDMODE AND TMP:TYPE < 50; GET(TMPQUE,TMP:TYPE)
        IF NOT ERROR(); SHOWMSG('Can''t add new template. A template already exists for this type of document.'); BREAK.
        ELSE; TMPQUE = TMPGRP.
        DO PUTTMP;  BREAK
        OF ?BROWSE; TMP:PATH = BROWSE(2)
        OF ?BROWSE2; TMP:APPPATH = BROWSE(1)
        ..
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
PUTTMP  ROUTINE
        DOCQUE :=: TMPQUE; DOQ:ID = -1
        CASE MODE
        OF ADDMODE OROF CREATEMODE; DOC:RECORD = DOCQUE; ADD(DOCS); TMP:POINTER = POINTER(DOCS); ADD(TMPQUE)
        OF EDITMODE; GET(DOCS,TMP:POINTER); DOC:RECORD = DOCQUE; PUT(TMPQUE); PUT(DOCS)
        OF DELMODE; GET(DOCS,TMP:POINTER); DELETE(DOCS); DELETE(TMPQUE)
        .

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
WRITEMERGE  PROCEDURE
NDX     SHORT
SCSZ     STRING(50)
SAVPTR  SHORT
        CODE
        DOSFILENAME = CLIP(DOCPATH) & 'ClasInfo.txt'; REMOVE(DOSFILE); CREATE(DOSFILE)
        OPEN(DOSFILE)
        DOS:STRING = 'CLANAME~SDATE~EDATE~STIME~ETIME~FULLNAME~'; ADD(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = 'CLAAVG~STUCNT~STUFNAME~STUMNAME~STULNAME~STUNAME~STUAVG~STURANK~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = 'ASSNAME~ASSDUE~ASSCAT~TEANAME~TEAADD1~TEAADD2~TEACSZ' & CHR(13) & CHR(10); APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))

        STU:SSN = NAM:SSN; GET(STUDENT,STU:SSNKEY)
        DOS:STRING = CLIP(CUR:NAME) & '~' & FORMAT(CUR:SDATE,@D1) & '~' & FORMAT(CUR:EDATE,@D1) & '~' & FORMAT(CUR:STIME,@T3) & '~' & FORMAT(CUR:ETIME,@T3) & '~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = CLIP(CUR:CCLASSNAME) & '~' & CLIP(CUR:AVGAVG) & '~' & CLIP(CUR:TOTSTU) & '~' & CLIP(STU:FNAME) & '~' & CLIP(STU:MNAME) & '~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = CLIP(STU:LNAME) &'~' & CLIP(NAM:NAME) & '~' & NAM:AVG & '~' & NAM:RANK & '~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = CLIP(ALL:NAME) & '~' & FORMAT(ALL:DDATE,@D1) & '~' &  CLIP(CAT:NAME) & '~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = CLIP(USERNAME) & '~' & CLIP(ADDRESS1) & '~' &  CLIP(ADDRESS2) & '~' & CLIP(CSZ); APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        CLOSE(DOSFILE)

        DOSFILENAME = CLIP(DOCPATH) & 'StuInfo.txt'; REMOVE(DOSFILE); CREATE(DOSFILE); OPEN(DOSFILE)
        DOS:STRING = 'NAME~FNAME~MNAME~LNAME~AVG~RANK~IDNUM~'; ADD(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = 'ADD1~CSZ~PHONE' & CHR(13) & CHR(10); APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))

        SAVPTR = POINTER(NAMQUE)
        LOOP NDX = 1 TO RECORDS(NAMQUE); GET(NAMQUE,NDX); STU:SSN = NAM:SSN; GET(STUDENT,STU:SSNKEY)
        CSZ = CLIP(STU:CITY) & ' ,' & STU:STATE & '  ' & STU:ZIP
        DOS:STRING = CLIP(NAM:NAME) & '~' & CLIP(STU:FNAME) & '~' & CLIP(STU:MNAME) & '~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = CLIP(STU:LNAME) & '~' & CLIP(NAM:AVG) & '~' & CLIP(NAM:RANK) & '~'; APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        DOS:STRING = CLIP(NAM:SSN) & '~' & CLIP(STU:STREET) & '~' & CLIP(SCSZ) & '~' & CLIP(STU:PHONE1) & CHR(13) & CHR(10); APPEND(DOSFILE,LEN(CLIP(DOS:STRING)))
        .
        GET(NAMQUE,SAVPTR); CLOSE(DOSFILE)

        FOPEN(DBASESTU); EMPTY(DBASESTU)
        LOOP NDX = 1 TO RECORDS(NAMQUE); GET(NAMQUE,NDX); STU:SSN = NAM:SSN; GET(STUDENT,STU:SSNKEY)
        DBS:RECORD = STU:RECORD; DBS:NAME = NAM:NAME; DBS:AVG = NAM:AVG; DBS:RANK = NAM:RANK; APPEND(DBASESTU)
        .
        FOPEN(DBASECLA); EMPTY(DBASECLA)
        DBC:CLAGRP :=: CURDATA; DBC:NAMGRP :=: NAMQUE; DBC:ASSGRP :=: ALLQUE
        DBC:ASSNAME = ALL:NAME; DBC:STUNAME = NAM:NAME; DBC:USERNAME = USERNAME
        !DBC:SDATE = FORMAT(CUR:SDATE,@D1); DBC:EDATE = FORMAT(CUR:EDATE,@D1)
        !DBC:STIME = FORMAT(CUR:STIME,@T3); DBC:ETIME = FORMAT(CUR:EDATE,@T3); DBC:USERNAME = USERNAME
        APPEND(DBASECLA)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
FILDOCQUEUE PROCEDURE(THECLASS)
WINDIR  STRING(50)
        CODE
        SAVPATH = PATH(); DOCPATH = CLIP(SAVPATH) & '\DOCS\'
        FOPEN(DOCS,22h); WINVER = GETVERSION()
        IF GETINI('USER','DOCSETUP','0','.\CLASMATE.INI') = '0'; DO SETUPNEW.
        PGMPATH = GETINI('USER','DOCPGM',,'.\CLASMATE.INI')
        ADDRESS1 = GETINI('USER','ADDRESS1','','.\CLASMATE.INI')
        ADDRESS2 = GETINI('USER','ADDRESS2','','.\CLASMATE.INI')
        CSZ = GETINI('USER','CSZ','','.\CLASMATE.INI')
        FREE(DOCQUE); CLEAR(DOCQUE); FREE(TMPQUE); CLEAR(TMPQUE)
        SET(DOCS,1); LOOP UNTIL EOF(DOCS); NEXT(DOCS)
        IF DOC:ID < 0; TMPQUE :=: DOC:RECORD; TMP:POINTER = POINTER(DOCS); ADD(TMPQUE)
        ELSE
        IF ((DOC:ID <> THECLASS) OR |
        (DOC:TYPE = 4 OR DOC:TYPE = 5 AND DOC:SUBJECT <> CUR:SUBJECT AND DOC:ID <> 0)) AND THECLASS <> 0; CYCLE.
        DOCQUE = DOC:RECORD; DOQ:POINTER = POINTER(DOCS); ADD(DOCQUE).
        .
        SORT(DOCQUE,DOQ:TYPE,DOQ:ID,DOQ:SUBJECT,DOQ:GRANUM,DOQ:SSN); SORT(TMPQUE,TMP:TYPE)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SETUPNEW    ROUTINE
        WINDIR = GETWINDIR()
        SET(DOCS,1); LOOP UNTIL EOF(DOCS); NEXT(DOCS); IF DOC:ID > 0; CYCLE.
        FILESPLIT(DOC:PATH)
        DOC:PATH = CLIP(DOCPATH) & CLIP(PAT:NAME) & PAT:EXT
        IF FILEEXISTS(CLIP(WINDIR) & '\WRITE.EXE'); DOC:APPPATH = 'WRITE.EXE'
        ELSIF FILEEXISTS(CLIP(WINDIR) & '\WORDPAD.EXE'); DOC:APPPATH = 'WORDPAD.EXE'.
        PUT(DOCS)
        .
        PUTINI('USER','DOCSETUP','1','.\CLASMATE.INI')

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
CREATEFILENAME  FUNCTION(THEPATH)
NDX     SHORT(1)
NDX2    SHORT
NUMBER  STRING(4)
        CODE
        FREE(FILEQUE); CLEAR(FILEQUE); FILESPLIT(THEPATH)
        PAT:NAME = CLIP(PAT:NAME) & '00000000'; PAT:NAME = SUB(PAT:NAME,1,4)
        DIRECTORY(FILEQUE,CLIP(PAT:DRIVE) & CLIP(PAT:PATH) & CLIP(PAT:NAME) & '*' & PAT:EXT,1); SORT(FILEQUE,FIL:NAME)
        LOOP NDX2 = 1 TO RECORDS(FILEQUE); GET(FILEQUE,NDX2); NUMBER = SUB(FIL:NAME,5,4)
        IF NOT NUMERIC(NUMBER); CYCLE.
        IF NDX < NUMBER; BREAK.
        NDX += 1
        .
        PAT:NAME = CLIP(PAT:NAME) & FORMAT(NDX,@N04)
        RETURN(CLIP(PAT:DRIVE) & CLIP(PAT:PATH) & CLIP(PAT:NAME) & PAT:EXT)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SETDOC  PROCEDURE(DOCTYPE,THETMP)
        CODE
        IF OMITTED(2); TMP:TYPE = DOCTYPE; GET(TMPQUE,TMP:TYPE); ELSE; TMP:PATH = THETMP.
        DOQ:TYPE = DOCTYPE; DOQ:ID = CUR:ID; DOQ:SSN = ''; DOQ:GRANUM = 0; DOQ:SUBJECT = 0
        IF INRANGE(DOCTYPE,11,20); DOQ:SUBJECT = CUR:SUBJECT; DOQ:GRANUM = ALL:GRANUM.
        IF INRANGE(DOCTYPE,21,30); DOQ:SSN = NAM:SSN.
        IF TMP:PATH; DOQ:PATH = CREATEFILENAME(TMP:PATH); ELSE DOQ:PATH = ''; CLEAR(PATHGRP).
        DOQ:TITLE = SUB(PAT:NAME,1,4)
        CASE DOCTYPE
        OF 1 TO 10; DOQ:TITLE = CLIP(DOQ:TITLE) & ': ' & CUR:NAME  !ATTACH TO CLASS
        OF 11 TO 20; DOQ:TITLE = CLIP(DOQ:TITLE) & ': ' & ALL:NAME !ATTACH TO ASSIGNMENT
        OF 21 TO 30; DOQ:TITLE = CLIP(DOQ:TITLE) & ': ' & NAM:NAME !ATTACH TO STUDENT
        OF 31 TO 50; DOQ:TITLE = CLIP(DOQ:TITLE) & ': ' & PAT:NAME & PAT:EXT
        .
        DOQ:APPPATH = TMP:APPPATH; SAV:DOQPATH = DOQ:PATH
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
BROWSE  FUNCTION(MODE)
FILESPEC    LIKE(DOC:APPPATH)
        CODE
        CASE MODE
        OF  1       !RETURN AN APPLICATION
        IF FILEDIALOG('Select File',FILESPEC,'Program Files(.exe)|*.exe|All Files(*.*)|*.*|',0)
        .
        OF 2        !RETURN A TEMPLATE
        IF FILEDIALOG('Select Document',FILESPEC, 'Document Files|*.doc;*.txt;*.wri;*.rtf|All Files(*.*)|*.*|',0)
        !FILESPLIT(DOQ:PATH); DOQ:FILE = PAT:NAME & PAT:EXT
        DIRECTORY(FILEQUE,DOQ:PATH,1); GET(FILEQUE,1); DOQ:DATE = FIL:DATE
        SETDOC(TMP:TYPE,FILESPEC)
        ..
        SETPATH(SAVPATH); RETURN(FILESPEC)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
RUNDOC PROCEDURE(THEAPP,THEDOC)
        CODE
        IF MERGE; WRITEMERGE.
        FILESPLIT(THEAPP); SETPATH(PAT:DRIVE & PAT:PATH)
        RUN(CLIP(THEAPP) & ' ' & THEDOC); SETPATH(SAVPATH)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!CHECKFILE   PROCEDURE(THEDOC)
 !           CODE
  !          IF FILEEXISTS(THEDOC); STOP().


















